unit WksFunction_IMPL;

interface

uses
  ComObj, ComServ, adxAddIn, Variants, WksFunction_TLB, StdVcl,
  Excel2000;

type

  TWksFunc = class(TadxAddin, IWksFunc)
  protected
    function MyFunc(var Range: OleVariant): Integer; safecall;
  end;

  TAddInModule = class(TadxCOMAddInModule)
  private
  protected
  public
  end;

implementation

{$R *.dfm}

function TWksFunc.MyFunc(var Range: OleVariant): Integer;
begin
  try
    Result := 0;
    case VarType(Range) of
      varDispatch: Result := Range.Cells[1, 1].Value div 2;

      varSmallint, varInteger, varSingle,
      varDouble, varCurrency, varShortInt, varByte,
      varWord, varLongWord, varInt64: Result := Range div 2;
    end;
  except
    Result := CVErr(xlErrNull);
  end;
end;

initialization
  TadxFactory.Create(ComServer, TWksFunc, CLASS_WksFunc, TAddInModule);

end.
